package com.lzmispt.data.resource.manager.file;

package .tmp;

import com.lzmispt.data.center.entity.dto.resource.apply.GetFileTableInfoVO;
import com.lzmispt.data.resource.client.DataApplyClient;
import com.lzmispt.data.resource.dao.file.IFileInfoFieldDao;
import com.lzmispt.data.resource.dao.file.IFileInfoTableDao;
import com.lzmispt.data.resource.dao.resources.IResourceFileInfoFieldDao;
import com.lzmispt.data.resource.dao.resources.IResourceFileInfoTableDao;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataFileFieldDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataFileTableDTO;
import com.lzmispt.data.resource.entity.po.file.FileInfoTablePO;
import com.lzmispt.data.resource.entity.po.resources.ResFileInfoTablePO;
import com.lzmispt.dcbase.ServiceUtil;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.dcbase.log.CommonLogHelper;
import com.lzmispt.dcbase.util.ResAndDataUtil;
import com.lzmispt.framework.entity.entity.ResultEntity;
import java.util.ArrayList;
import java.util.List;
import java.util.function.Supplier;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class FileInfoManager {
  private static DataApplyClient DATA_APPLY_CLIENT;
  
  @Autowired
  public void setDataApplyClient(DataApplyClient dataApplyClient) {
    DATA_APPLY_CLIENT = dataApplyClient;
  }
  
  public static ResAndDataFileTableDTO getFileTableById(Long fileTableId, String platCode, Integer dataCategory, String tokenId) {
    if ("Apply".equals(platCode) && DCConst.DataResourceCategory.DATA.equals(dataCategory)) {
      ResultEntity<GetFileTableInfoVO> getFileTableInfoVOResultEntity = DATA_APPLY_CLIENT.getFileTableInfoByFileTableId(fileTableId, tokenId);
      ResAndDataFileTableDTO resAndDataFileTableDTO = null;
      if (!getFileTableInfoVOResultEntity.getCode().equals(DCConst.FALSE)) {
        CommonLogHelper.consoleError("未查询到应用平台文件信息表信息", "fileTableId：" + fileTableId, DCConst.ServerClientType.RESOURCE);
      } else if (getFileTableInfoVOResultEntity.getObj() != null) {
        GetFileTableInfoVO getFileTableInfoVO = (GetFileTableInfoVO)getFileTableInfoVOResultEntity.getObj();
        resAndDataFileTableDTO = new ResAndDataFileTableDTO();
        resAndDataFileTableDTO.setFileTableId(Long.valueOf(Long.parseLong(getFileTableInfoVO.getFileTableInfo().getFileTableId())));
        resAndDataFileTableDTO.setFileTableName(getFileTableInfoVO.getFileTableInfo().getFileTableName());
        resAndDataFileTableDTO.setFileTableCnName(getFileTableInfoVO.getFileTableInfo().getFileTableCnName());
        resAndDataFileTableDTO.setFileRootPath(getFileTableInfoVO.getFileTableInfo().getFileRootPath());
        resAndDataFileTableDTO.setDataSourceId(Long.valueOf(Long.parseLong(getFileTableInfoVO.getFileTableInfo().getDataSourceId())));
      } 
      return resAndDataFileTableDTO;
    } 
    return (ResAndDataFileTableDTO)ResAndDataUtil.simpleGet(dataCategory, () -> ((IResourceFileInfoTableDao)ServiceUtil.getResFileInfoTableDao(platCode, IResourceFileInfoTableDao.class)).getFileTableById(fileTableId), () -> ((IFileInfoTableDao)ServiceUtil.getFileInfoTableDao(platCode, IFileInfoTableDao.class)).getFileTableById(fileTableId), ResAndDataFileTableDTO::new);
  }
  
  public static List<ResAndDataFileFieldDTO> selectFileInfoFieldsByFileTableId(Long fileTableId, String platCode, Integer dataCategory, String tokenId) {
    if ("Apply".equals(platCode) && DCConst.DataResourceCategory.DATA.equals(dataCategory)) {
      ResultEntity<GetFileTableInfoVO> getFileTableInfoVOResultEntity = DATA_APPLY_CLIENT.getFileTableInfoByFileTableId(fileTableId, tokenId);
      List<ResAndDataFileFieldDTO> resAndDataFileFieldDTOList = null;
      if (!getFileTableInfoVOResultEntity.getCode().equals(DCConst.FALSE)) {
        CommonLogHelper.consoleError("未查询到应用平台文件信息表信息", "fileTableId：" + fileTableId, DCConst.ServerClientType.RESOURCE);
      } else if (getFileTableInfoVOResultEntity.getObj() != null) {
        GetFileTableInfoVO getFileTableInfoVO = (GetFileTableInfoVO)getFileTableInfoVOResultEntity.getObj();
        List<GetFileTableInfoVO.FieldInfo> fieldList = getFileTableInfoVO.getFieldList();
        if (!CollectionUtils.isEmpty(fieldList)) {
          resAndDataFileFieldDTOList = new ArrayList<>();
          for (GetFileTableInfoVO.FieldInfo fieldInfo : fieldList) {
            ResAndDataFileFieldDTO resAndDataFileFieldDTO = new ResAndDataFileFieldDTO();
            BeanUtils.copyProperties(fieldInfo, resAndDataFileFieldDTO);
            resAndDataFileFieldDTO.setFieldId(Long.valueOf(Long.parseLong(fieldInfo.getFieldId())));
            resAndDataFileFieldDTO.setFileTableId(Long.valueOf(Long.parseLong(fieldInfo.getFileTableId())));
            resAndDataFileFieldDTOList.add(resAndDataFileFieldDTO);
          } 
        } 
      } 
      return resAndDataFileFieldDTOList;
    } 
    return ResAndDataUtil.simpleGetList(dataCategory, () -> ((IResourceFileInfoFieldDao)ServiceUtil.getResFileInfoFieldDao(platCode, IResourceFileInfoFieldDao.class)).selectFileInfoFieldsByFileTableId(fileTableId), () -> ((IFileInfoFieldDao)ServiceUtil.getFileInfoFieldDao(platCode, IFileInfoFieldDao.class)).selectFileInfoFieldsByFileTableId(fileTableId), ResAndDataFileFieldDTO::new);
  }
  
  public static ResAndDataFileTableDTO getFileTableById(Long fileTableId, String platCode, Integer dataCategory) {
    return (ResAndDataFileTableDTO)ResAndDataUtil.simpleGet(dataCategory, () -> ((IResourceFileInfoTableDao)ServiceUtil.getResFileInfoTableDao(platCode, IResourceFileInfoTableDao.class)).getFileTableById(fileTableId), () -> ((IFileInfoTableDao)ServiceUtil.getFileInfoTableDao(platCode, IFileInfoTableDao.class)).getFileTableById(fileTableId), ResAndDataFileTableDTO::new);
  }
  
  public static List<ResAndDataFileFieldDTO> selectFileInfoFieldsByFileTableId(Long fileTableId, String platCode, Integer dataCategory) {
    return ResAndDataUtil.simpleGetList(dataCategory, () -> ((IResourceFileInfoFieldDao)ServiceUtil.getResFileInfoFieldDao(platCode, IResourceFileInfoFieldDao.class)).selectFileInfoFieldsByFileTableId(fileTableId), () -> ((IFileInfoFieldDao)ServiceUtil.getFileInfoFieldDao(platCode, IFileInfoFieldDao.class)).selectFileInfoFieldsByFileTableId(fileTableId), ResAndDataFileFieldDTO::new);
  }
}
